VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Bitmap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Class name :Bitmap
'By Xing
'Date:2/18/1999
'          3/31/1999 ӵɫ巽  buildFadeBits
'          3/31/1999 ӵFadeIn,FadeOut


'//////////////// 豸޹λͼ (DIB)ĴСɫϢ  (λ bmp ļĿͷ)
Private Type BITMAPINFOHEADER
    biSize As Long                         'ṹ
    biWidth As Long                        'ָλͼĿȣΪλ
    biHeight As Long                       ' "    "   ߶   "   "
    biPlanes As Integer                    'ָĿ豸ļ(Ϊ 1 )
    biBitCount As Integer                  'ÿһصλ(148162432)
    biCompression As Long                  'ָѹ(BI_RGB Ϊѹ)
    biSizeImage As Long                    'ָͼĴСֽΪλ
    biXPelsPerMeter As Long                'ָ豸ˮƽֱʣÿ׵Ϊλ
    biYPelsPerMeter As Long                'ֱֱʣͬ
    biClrUsed As Long                      'ɫʵʹõɫĸOʾȫҪʹ
    biClrImportant As Long                 'ָΪҪɫ 0 ʾɫҩ
End Type
'//////////////// ɺ졢̡ɵɫ
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte    'Ϊ 0
End Type
'//////////////// DIB ĴСɫϢ
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(0 To 255) As RGBQUAD
End Type
'/////////////// DIB ļСṹϢ
Private Type BITMAPFILEHEADER
    bfType As Integer                       'ָļͣ BM
    bfSize As Long                          'ָλͼļСֽΪλ
    bfReserved1 As Integer                  'Ϊ0
    bfReserved2 As Integer                  'ͬ
    bfOffBits As Long                       'Ӵ˽ṹλͼλֽƫ
End Type

Private Const SRCCOPY& = &HCC0020
Private Const CBM_INIT& = &H4
Private Const DIB_RGB_COLORS& = 0
Private Const GENERIC_READ& = &H80000000
Private Const GENERIC_WRITE& = &H40000000
Private Const CREATE_NEW& = 1
Private Const OPEN_EXISTING& = 3
Private Const FILE_ATTRIBUTE_NORMAL& = &H80


Private Declare Function StretchDIBits& Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dX As Long, ByVal dY As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, ByVal lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long)
Private Declare Function CloseHandle& Lib "kernel32" (ByVal hObject As Long)
Private Declare Function CreateFile& Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long)
Private Declare Function ReadFile& Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesTOread As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long)
Private Declare Function ReadFileGlobal Lib "kernel32" Alias "ReadFile" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesTOread As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function WriteFile& Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long)
Private Declare Function WriteFileGlobal& Lib "kernel32" Alias "WriteFile" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long)
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


'Member of the Bitmap class
Dim m_MyMem As MyMemory
Dim m_BMInfo As BITMAPINFO
Dim m_BitData() As Byte
Dim m_BMFileHeader As BITMAPFILEHEADER
Dim m_FilePointer As Long
Dim m_ReadFileName As String
Dim m_WriteFileName As String
Dim m_ColorIndex As Integer
Dim m_FadeBMInfo() As BITMAPINFO



'Set/get file name
Public Property Let WriteFileName(S As String)
      m_WriteFileName = S
End Property
Public Property Get WriteFileName() As String
      WriteFileName = m_WriteFileName
End Property
Public Property Let ReadFileName(S As String)
      m_ReadFileName = S
End Property
Public Property Get ReadFileName() As String
      ReadFileName = m_ReadFileName
End Property


'Set/get file pointer
Public Property Let FilePointer(S As String)
      m_FilePointer = S
End Property
Public Property Get FilePointer() As String
      FilePointer = m_FilePointer
End Property

'Get and set the index into the color array for the picture
Public Property Let ColorIndex(i As Integer)
      m_ColorIndex = i
End Property
Public Property Get ColorIndex() As Integer
      ColorIndex = m_ColorIndex
End Property

'Get and set RGBcolor
Public Property Get red() As Long
      red = m_BMInfo.bmiColors(m_ColorIndex).rgbRed
End Property
Public Property Let red(L As Long)
      m_BMInfo.bmiColors(m_ColorIndex).rgbRed = L
End Property
Public Property Get Green() As Long
      Green = m_BMInfo.bmiColors(m_ColorIndex).rgbGreen
End Property
Public Property Let Green(L As Long)
      m_BMInfo.bmiColors(m_ColorIndex).rgbGreen = L
End Property
Public Property Get Blue() As Long
      Blue = m_BMInfo.bmiColors(m_ColorIndex).rgbBlue
End Property
Public Property Let Blue(L As Long)
      m_BMInfo.bmiColors(m_ColorIndex).rgbBlue = L
End Property

'Get and Set bitmap
Public Property Get BitPointer() As Long
      BitPointer = m_MyMem.MemPointer
End Property
Public Property Let BitPointer(L As Long)
      m_MyMem.MemPointer = L
End Property

'Sets and returns the size of bitmap pixel data
Public Property Get DataSize() As Long
      DataSize = m_BMInfo.bmiHeader.biSizeImage
End Property
Public Property Let DataSize(L As Long)
      m_BMInfo.bmiHeader.biSizeImage = L
End Property


'////////////////////////////////////////////
'Open the file
Public Sub OpenFile()
      m_FilePointer = CreateFile(m_ReadFileName, GENERIC_READ Or GENERIC_WRITE, 0&, 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0&)
     
End Sub

'Read the file header
Public Sub ReadFileHeader()
      Dim N As Long
      Dim dl&

      dl& = ReadFile(m_FilePointer, m_BMFileHeader.bfType, Len(m_BMFileHeader), N, 0&)
End Sub

'Read the bitmap header
Public Sub ReadBitmapHeader()
      Dim N As Long
      Dim dl&
      dl& = ReadFile(m_FilePointer, m_BMInfo.bmiHeader.biSize, Len(m_BMInfo.bmiHeader), N, 0&)
End Sub

'Read the color table
Public Sub ReadColorTable()
      Dim N As Long
      Dim dl As Long
      dl& = ReadFile(m_FilePointer, m_BMInfo.bmiColors(0), Len(m_BMInfo.bmiColors(0)) * 256, N, 0&)
End Sub

'read bitmap data to memore
Public Sub ReadBitData()
      Dim N As Long
      Dim dl As Long
      Set m_MyMem = New MyMemory
      
        
      m_MyMem.MemSize = m_BMInfo.bmiHeader.biSizeImage
      m_MyMem.GAlloc
      m_MyMem.GLock
      dl& = ReadFileGlobal(m_FilePointer, m_MyMem.MemPointer, m_BMInfo.bmiHeader.biSizeImage, N, 0&)
End Sub

'Close file
Public Sub CloseFile()
      Dim dl As Long
      dl& = CloseHandle(m_FilePointer)
End Sub

'Write bitmap data to file
Public Sub WriteBitmap()
      Dim FileP As Long
      Dim dl As Long
      Dim N As Long
      m_FilePointer = CreateFile(m_WriteFileName, GENERIC_READ Or GENERIC_WRITE, 0&, _
                 0&, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, 0&)
      'write the file header
      dl& = WriteFile(m_FilePointer, m_BMFileHeader.bfType, Len(m_BMFileHeader), N, 0&)
      'write the bitmap header
      dl& = WriteFile(m_FilePointer, m_BMInfo.bmiHeader.biSize, Len(m_BMInfo.bmiHeader), N, 0&)
    
      dl& = WriteFile(m_FilePointer, m_BMInfo.bmiColors(0), Len(m_BMInfo.bmiColors(0)) * 256, N, 0&)
      dl& = WriteFileGlobal(m_FilePointer, m_MyMem.MemPointer, m_BMInfo.bmiHeader.biSizeImage, N, 0&)
      
      dl& = CloseHandle(m_FilePointer)
      
      m_MyMem.GUnLock
      m_MyMem.GFree
End Sub
'ɫ
Public Sub buildFadeBits()
      Dim i As Integer
      Dim N As Integer
      Dim T As Integer
      ReDim m_FadeBMInfo(20)
      Dim bminfo As BITMAPINFO
      bminfo = m_BMInfo
      For N = 0 To 255
              m_FadeBMInfo(0).bmiColors(N) = m_BMInfo.bmiColors(N)
              m_FadeBMInfo(0).bmiHeader = bminfo.bmiHeader
      Next N
      For i = 1 To 20
          For N = 0 To 255
              T = bminfo.bmiColors(N).rgbRed
                  If T > 19 Then T = T - 20 Else T = 0
                  bminfo.bmiColors(N).rgbRed = T
              T = bminfo.bmiColors(N).rgbGreen
                  If T > 19 Then T = T - 20 Else T = 0
                  bminfo.bmiColors(N).rgbGreen = T
              T = bminfo.bmiColors(N).rgbBlue = T
                  If T > 19 Then T = T - 20 Else T = 0
                  bminfo.bmiColors(N).rgbBlue = T
              bminfo.bmiColors(N).rgbReserved = 0
          
              m_FadeBMInfo(i).bmiColors(N).rgbBlue = bminfo.bmiColors(N).rgbBlue
              m_FadeBMInfo(i).bmiColors(N).rgbGreen = bminfo.bmiColors(N).rgbGreen
              m_FadeBMInfo(i).bmiColors(N).rgbRed = bminfo.bmiColors(N).rgbRed
              m_FadeBMInfo(i).bmiColors(N).rgbReserved = bminfo.bmiColors(N).rgbReserved
          Next N
              m_FadeBMInfo(i).bmiHeader = bminfo.bmiHeader
      Next i
End Sub
'ʾԲЧ
Public Sub FadeIn(pic As Control, intWait As Integer)
     Dim i As Integer
     Dim dl&
     
     For i = 20 To 0 Step -1
         dl& = StretchDIBits(pic.hDC, 0, 0, pic.Width, pic.Height, _
                                 0, 0, pic.Width, pic.Height, _
                                 ByVal m_MyMem.MemPointer, m_FadeBMInfo(i), DIB_RGB_COLORS, SRCCOPY)
         Wait intWait
     Next i
      m_MyMem.GUnLock
      m_MyMem.GFree
End Sub
'ʾԲЧ
Public Sub FadeOut(pic As Control, intWait As Integer)
     Dim i As Integer
     Dim dl&
     
     For i = 0 To 20
         dl& = StretchDIBits(pic.hDC, 0, 0, pic.Width, pic.Height, _
                                 0, 0, pic.Width, pic.Height, _
                                 ByVal m_MyMem.MemPointer, m_FadeBMInfo(i), DIB_RGB_COLORS, SRCCOPY)
         Wait intWait
     Next i

      m_MyMem.GUnLock
      m_MyMem.GFree
End Sub
Private Sub Wait(count As Integer)
   Dim i As Integer
        For i = 0 To count
           Sleep 1
           DoEvents
        Next
End Sub


